Subject: Re: bug#31315: wrong font encoding for fallback font

From: Eli Zaretskii <[email-masked]>
Date: Thu, 03 May 2018 20:48:44 +0300

> Date: Thu, 03 May 2018 07:52:27 +0200 (CEST)
> Cc: [email-masked], [email-masked]
> From: Werner LEMBERG <[email-masked]>
> 
> > Emacs employs that logic for every charset it has defined, including
> > Latin-2, for example: if text was decoded from an encoding which
> > supports a particular charset, Emacs puts the corresponding
> > 'charset' text property on the decoded text, and the machinery which
> > selects the appropriate font tries first to find a font which
> > supports that charset.  The idea is that users in a particular
> > culture have certain distinct preferences wrt fonts, and that an
> > encoding that supports a certain charset or culture provides a hint
> > about those preferences.  This idea is very central in how Emacs
> > selects fonts.
> 
> Being the FreeType maintainer, and having co-developed Emacs's
> internal buffer encoding scheme many, many years ago, I all know this.

Sorry, I couldn't know that.

> I can only repeat that Emacs might tag a certain text with GB18030 so
> that the user can deduce a Chinese origin.  However, there is *no*
> guarantee that the user gets a Chinese-flavoured font – at least not
> from the xft interface.[**]

IME, there's no guarantee about anything in the Emacs font look up
heuristics, except that empirically it does TRT in about 85% of uses.

May I invite you to work on revisiting the design and implementation
of the Emacs font-look up facilities, and on modernizing them?  I'm
afraid we didn't have an active developer in this area for several
years, and I fear that we will stagnate (or already are stagnating).

TIA